#!/bin/sh

ret=0
jobs=${jobs:-$((`sysctl -n hw.ncpu`+1))}
nice=${nice:-20}
kernel=${kernel:-0}
world=${world:-0}
keepit=${keepit:-}
KERNCONF=${KERNCONF:-`make -VKERNCONF`}

for i in $*; do
	[ x"$i" = x"-safe"     ] && jobs=1
	[ x"$i" = x"-fast"     ] && nice=-10
	[ x"$i" = x"-kernel"   ] && world=1
	[ x"$i" = x"-world"    ] && kernel=1
	[ x"$i" = x"-keepit"   ] && keepit="-DNO_CLEAN -DNO_KERNELCLEAN -DNO_KERNELDEPEND"
done

start=${start:-`date +%s`}

if [ ${world} -eq 0 ]; then
	nice -${nice} make -j${jobs} ${keepit} buildworld
	ret=$?
	[ ${kernel} -eq 0 ] && kernel=${ret}
fi

if [ ${kernel} -eq 0 ]; then
	nice -${nice} make -j${jobs} ${keepit} buildkernel KERNCONF=${KERNCONF}
	ret=$?
fi

echo ""
echo "END TIME: `date`"
echo " "$((`date +%s` - ${start})) "sec"

exit $ret
